package com.rebusland.fin.derivatives.eq.server.http.response.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import com.rebusland.fin.derivatives.eq.server.output.model.PricingResults;
import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class PricingResponse extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final Long id;

	@PropertyDefinition(validate = "notNull")
	private final PricingResults pricingResults;

	@PropertyDefinition
	private final String errorMessage;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code PricingResponse}.
	 * @return the meta-bean, not null
	 */
	public static PricingResponse.Meta meta() {
		return PricingResponse.Meta.INSTANCE;
	}

	static {
		MetaBean.register(PricingResponse.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static PricingResponse.Builder builder() {
		return new PricingResponse.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected PricingResponse(PricingResponse.Builder builder) {
		JodaBeanUtils.notNull(builder.id, "id");
		JodaBeanUtils.notNull(builder.pricingResults, "pricingResults");
		this.id = builder.id;
		this.pricingResults = builder.pricingResults;
		this.errorMessage = builder.errorMessage;
	}

	@Override
	public PricingResponse.Meta metaBean() {
		return PricingResponse.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the id.
	 * @return the value of the property, not null
	 */
	public Long getId() {
		return id;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the pricingResults.
	 * @return the value of the property, not null
	 */
	public PricingResults getPricingResults() {
		return pricingResults;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the errorMessage.
	 * @return the value of the property
	 */
	public String getErrorMessage() {
		return errorMessage;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			PricingResponse other = (PricingResponse) obj;
			return JodaBeanUtils.equal(id, other.id) &&
					JodaBeanUtils.equal(pricingResults, other.pricingResults) &&
					JodaBeanUtils.equal(errorMessage, other.errorMessage);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(id);
		hash = hash * 31 + JodaBeanUtils.hashCode(pricingResults);
		hash = hash * 31 + JodaBeanUtils.hashCode(errorMessage);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(128);
		buf.append("PricingResponse{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("id").append('=').append(JodaBeanUtils.toString(id)).append(',').append(' ');
		buf.append("pricingResults").append('=').append(JodaBeanUtils.toString(pricingResults)).append(',').append(' ');
		buf.append("errorMessage").append('=').append(JodaBeanUtils.toString(errorMessage)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code PricingResponse}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code id} property.
		 */
		private final MetaProperty<Long> id = DirectMetaProperty.ofImmutable(
				this, "id", PricingResponse.class, Long.class);
		/**
		 * The meta-property for the {@code pricingResults} property.
		 */
		private final MetaProperty<PricingResults> pricingResults = DirectMetaProperty.ofImmutable(
				this, "pricingResults", PricingResponse.class, PricingResults.class);
		/**
		 * The meta-property for the {@code errorMessage} property.
		 */
		private final MetaProperty<String> errorMessage = DirectMetaProperty.ofImmutable(
				this, "errorMessage", PricingResponse.class, String.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"id",
				"pricingResults",
				"errorMessage");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					return id;
				case 460523856:  // pricingResults
					return pricingResults;
				case 1203236063:  // errorMessage
					return errorMessage;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public PricingResponse.Builder builder() {
			return new PricingResponse.Builder();
		}

		@Override
		public Class<? extends PricingResponse> beanType() {
			return PricingResponse.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code id} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Long> id() {
			return id;
		}

		/**
		 * The meta-property for the {@code pricingResults} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<PricingResults> pricingResults() {
			return pricingResults;
		}

		/**
		 * The meta-property for the {@code errorMessage} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<String> errorMessage() {
			return errorMessage;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					return ((PricingResponse) bean).getId();
				case 460523856:  // pricingResults
					return ((PricingResponse) bean).getPricingResults();
				case 1203236063:  // errorMessage
					return ((PricingResponse) bean).getErrorMessage();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code PricingResponse}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<PricingResponse> {

		private Long id;
		private PricingResults pricingResults;
		private String errorMessage;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(PricingResponse beanToCopy) {
			this.id = beanToCopy.getId();
			this.pricingResults = beanToCopy.getPricingResults();
			this.errorMessage = beanToCopy.getErrorMessage();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					return id;
				case 460523856:  // pricingResults
					return pricingResults;
				case 1203236063:  // errorMessage
					return errorMessage;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					this.id = (Long) newValue;
					break;
				case 460523856:  // pricingResults
					this.pricingResults = (PricingResults) newValue;
					break;
				case 1203236063:  // errorMessage
					this.errorMessage = (String) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public PricingResponse build() {
			return new PricingResponse(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the id.
		 * @param id  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder id(Long id) {
			JodaBeanUtils.notNull(id, "id");
			this.id = id;
			return this;
		}

		/**
		 * Sets the pricingResults.
		 * @param pricingResults  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder pricingResults(PricingResults pricingResults) {
			JodaBeanUtils.notNull(pricingResults, "pricingResults");
			this.pricingResults = pricingResults;
			return this;
		}

		/**
		 * Sets the errorMessage.
		 * @param errorMessage  the new value
		 * @return this, for chaining, not null
		 */
		public Builder errorMessage(String errorMessage) {
			this.errorMessage = errorMessage;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(128);
			buf.append("PricingResponse.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("id").append('=').append(JodaBeanUtils.toString(id)).append(',').append(' ');
			buf.append("pricingResults").append('=').append(JodaBeanUtils.toString(pricingResults)).append(',').append(' ');
			buf.append("errorMessage").append('=').append(JodaBeanUtils.toString(errorMessage)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
